"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JwtAuthGuard = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
class JwtAuthGuard extends passport_1.AuthGuard('jwt') {
    constructor(reflector) {
        super();
        this.reflector = reflector;
    }
    handleRequest(err, user, info, context) {
        const request = context.switchToHttp().getRequest();
        const allowAny = this.reflector.get('allow-any', context.getHandler());
        if (user)
            return user;
        if (allowAny)
            return true;
        throw new common_1.UnauthorizedException();
    }
}
exports.JwtAuthGuard = JwtAuthGuard;
//# sourceMappingURL=jwt.auth-guard.js.map