"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyController = void 0;
const axios_1 = require("@nestjs/axios");
const common_1 = require("@nestjs/common");
const common_2 = require("@nestjs/common");
const property_service_1 = require("./property.service");
const xml2js_1 = require("xml2js");
const _ = require("lodash");
const meta_service_1 = require("../meta/meta.service");
const meta_constants_1 = require("../meta/meta.constants");
let PropertyController = class PropertyController {
    constructor(propertyService, httpService, metaService) {
        this.propertyService = propertyService;
        this.httpService = httpService;
        this.metaService = metaService;
    }
    async createUpdateProperty(oldData, newData) {
        return await this.propertyService.createOrUpdate(oldData, newData);
    }
    async patchNewProperty(patchproperty) {
        console.log(" { patchproperty } ");
        let xmlAttempt = await this.httpService.get('https://rkproperty.mycrm.com/feed/genericportal/40157279725f1929a6ccbc03e2ee067d');
        xmlAttempt.subscribe((response) => {
            return new xml2js_1.Parser({ explicitArray: false }).parseString(response.data, (err, _xmlData) => {
                if (err) {
                    throw err;
                }
                console.log("{_propertiesMeta}, _.get(_xmlData, 'list.$')");
                this.metaService.findOneByMeta(meta_constants_1.META_CONSTANTS.propertiesMeta).then(_propertiesMeta => {
                    if (!_.get(_propertiesMeta, 'data.last_update') || _.get(_propertiesMeta, 'data.last_update') != _.get(_xmlData, 'list.$.last_update')) {
                        console.log("NOUPDATE : ", { _propertiesMeta }, _.get(_propertiesMeta, 'data.last_update'), _.get(_xmlData, 'list.$.last_update'));
                        console.log("_propertiesMeta last_update : ", _.get(_xmlData, 'list.$.last_update'));
                        this.metaService.createOrUpdate(meta_constants_1.META_CONSTANTS.propertiesMeta, _.get(_xmlData, 'list.$', {}));
                        this.propertyService.getAllProperties().then(getAllProperties => {
                            _.forEach(_.get(_xmlData, 'list.property', []), _property => {
                                let _newProperty = _.omit(_property, '$');
                                _.set(_newProperty, 'photo.url', _.map(_.get(_newProperty, 'photo.url', []), _image => _.get(_image, '_')));
                                _.set(_newProperty, 'last_update', _.get(_property, '$.last_update'));
                                let existingProperty = _.find(getAllProperties, _pr => _.get(_property, 'reference_number') == _.get(_pr, 'reference_number'));
                                if (_.get(existingProperty, 'last_update') != _.get(_newProperty, 'last_update'))
                                    console.log("existingProperty ==> ", _.get(existingProperty, 'last_update'), _.get(_newProperty, 'last_update'));
                                if (_.get(existingProperty, 'last_update') != _.get(_newProperty, 'last_update')) {
                                    try {
                                        console.log("_newProperty.bedroom BEFORE : ", _newProperty.bedroom, _newProperty.bathroom);
                                        _newProperty.bedroom = Number(_.toString(_newProperty === null || _newProperty === void 0 ? void 0 : _newProperty.bedroom).match(/\d+/g));
                                        _newProperty.bathroom = Number(_.toString(_newProperty === null || _newProperty === void 0 ? void 0 : _newProperty.bathroom).match(/\d+/g));
                                        console.log("_newProperty.bedroom AFTER : ", _newProperty.bedroom, _newProperty.bathroom);
                                        console.log("==============================");
                                    }
                                    catch (err) {
                                        console.log({ err }, { _newProperty });
                                    }
                                    let _property = existingProperty ? this.propertyService.updateProperty(existingProperty, _newProperty) : this.propertyService.createOrUpdate(existingProperty, _newProperty);
                                    _property
                                        .then(result => {
                                        console.log("Updated : ", _.get(_newProperty, 'title_en'));
                                    })
                                        .catch(err => {
                                        console.log(err);
                                    });
                                }
                                else {
                                }
                            });
                        });
                    }
                    else {
                        console.log("NO UPDATE last update issue");
                    }
                });
            });
        });
    }
    async getAllProperties(params) {
        return await this.propertyService.getAllProperties();
    }
    async getAllPropertiesFiltered(params) {
        return await this.propertyService.getAllPropertiesFiltered(params);
    }
    async getSingleProperty(reference_number) {
        return await this.propertyService.findOneByProperty(reference_number);
    }
};
__decorate([
    common_2.Post(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], PropertyController.prototype, "createUpdateProperty", null);
__decorate([
    common_2.Get('sync'),
    __param(0, common_2.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], PropertyController.prototype, "patchNewProperty", null);
__decorate([
    common_2.Get(),
    __param(0, common_1.Query()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], PropertyController.prototype, "getAllProperties", null);
__decorate([
    common_2.Post('list'),
    __param(0, common_2.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], PropertyController.prototype, "getAllPropertiesFiltered", null);
__decorate([
    common_2.Get(':reference_number'),
    __param(0, common_1.Param('reference_number')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], PropertyController.prototype, "getSingleProperty", null);
PropertyController = __decorate([
    common_2.Controller('properties'),
    __metadata("design:paramtypes", [property_service_1.PropertyService,
        axios_1.HttpService,
        meta_service_1.MetaService])
], PropertyController);
exports.PropertyController = PropertyController;
//# sourceMappingURL=property.controller.js.map