"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyService = void 0;
const mongoose_1 = require("mongoose");
const common_1 = require("@nestjs/common");
const mongoose_2 = require("@nestjs/mongoose");
const _ = require("lodash");
let PropertyService = class PropertyService {
    constructor(propertyModel) {
        this.propertyModel = propertyModel;
    }
    async createOrUpdate(oldData, newData) {
        return await this.propertyModel.create(oldData, newData, { upsert: true, new: true, setDefaultsOnInsert: true });
    }
    async updateProperty(oldData, newData) {
        return await this.propertyModel.findOneAndUpdate({ reference_number: oldData === null || oldData === void 0 ? void 0 : oldData.reference_number }, newData);
    }
    async updateManyProperties(oldData, newData) {
        return await this.propertyModel.updateMany(oldData, newData);
    }
    async findOneByProperty(reference_number) {
        return await this.propertyModel.findOne({ reference_number: reference_number });
    }
    async getAllProperties() {
        return this.propertyModel.find();
    }
    async getAllPropertiesFiltered(params) {
        let limit = Number(_.get(params, 'limit', 20));
        let page = Number(_.get(params, 'page', 0));
        let price_lt = Number(_.get(params, 'price_lt', 9999999999));
        let price_gt = Number(_.get(params, 'price_gt', 1));
        let bathroom = Number(_.get(params, 'bathroom', 1));
        let bedroom = Number(_.get(params, 'bedroom', 1));
        let search = _.get(params, 'search', []);
        let type = _.get(params, 'property_type', []);
        let orData = _.size(_.compact(search)) > 0 ? { $or: [
                { title_en: { $in: search } },
                { community: { $in: search } },
                { sub_community: { $in: search } },
                { city: { $in: search } },
                { reference_number: { $in: search } },
                { developer: { $in: search } },
            ] } : {};
        let andData = [
            { price: { $gte: price_gt } },
            { price: { $lte: price_lt } },
            { bedroom: { $gte: bedroom } },
            { bathroom: { $gte: bathroom } },
        ];
        if (_.size(type) > 0) {
            andData.push({ property_type: { $in: type } });
        }
        return await this.propertyModel.find(Object.assign(Object.assign({}, orData), { $and: andData }))
            .skip(limit * page).limit(limit);
    }
};
PropertyService = __decorate([
    common_1.Injectable(),
    __param(0, mongoose_2.InjectModel('Property')),
    __metadata("design:paramtypes", [mongoose_1.Model])
], PropertyService);
exports.PropertyService = PropertyService;
//# sourceMappingURL=property.service.js.map