"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertySchema = void 0;
const mongoose = require("mongoose");
mongoose.set('useNewUrlParser', true);
mongoose.set('useFindAndModify', false);
mongoose.set('useCreateIndex', true);
exports.PropertySchema = new mongoose.Schema({
    last_update: {
        type: String,
        unique: false,
        required: false
    },
    permit_number: {
        type: String,
        unique: false,
        required: false
    },
    reference_number: {
        type: String,
        unique: true,
        required: true
    },
    offering_type: {
        type: String,
        unique: false,
        required: false
    },
    property_type: {
        type: String,
        unique: false,
        required: false
    },
    price_on_application: {
        type: String,
        unique: false,
        required: false
    },
    price: {
        type: Number,
        unique: false,
        required: false
    },
    city: {
        type: String,
        unique: false,
        required: false
    },
    community: {
        type: String,
        unique: false,
        required: false
    },
    sub_community: {
        type: String,
        unique: false,
        required: false
    },
    title_en: {
        type: String,
        unique: false,
        required: false
    },
    description_en: {
        type: String,
        unique: false,
        required: false
    },
    completion_status: {
        type: String,
        unique: false,
        required: false
    },
    amenities: {
        type: String,
        unique: false,
        required: false
    },
    size: {
        type: Number,
        unique: false,
        required: false
    },
    bedroom: {
        type: Number,
        unique: false,
        required: false
    },
    bathroom: {
        type: Number,
        unique: false,
        required: false
    },
    agent: {
        type: Object,
        required: false,
        unique: false
    },
    developer: {
        type: String,
        unique: false,
        required: false
    },
    parking: {
        type: Number,
        unique: false,
        required: false
    },
    furnished: {
        type: String,
        unique: false,
        required: false
    },
    photo: {
        type: Object,
        required: false,
        unique: false
    },
    geopoints: {
        type: String,
        unique: false,
        required: false
    }
});
//# sourceMappingURL=propertySchema.js.map