import { HttpModule } from '@nestjs/axios';
import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { MetaService } from './meta.service';
import { MetaSchema } from './meta.schema';
import { Metacontroller } from './meta.controller';

@Module({
  imports: [
    MongooseModule.forFeature([{name: 'Meta', schema: MetaSchema}]),
    HttpModule
  ],
  exports: [MetaService],
  controllers: [Metacontroller],
  providers: [MetaService]
})
export class MetasModule {}
