import { HttpService } from '@nestjs/axios';
import { Param, Patch, Query, Req, UseGuards } from '@nestjs/common';
import { Body, Controller, Get, Post } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { Property } from './property.model';
import { PropertyService } from './property.service';

import { parseString, Parser } from 'xml2js'
import * as _ from 'lodash'
import { MetaService } from 'src/meta/meta.service';
import { META_CONSTANTS } from 'src/meta/meta.constants';

@Controller('properties')
export class PropertyController {

    constructor(
        private propertyService: PropertyService, 
        private httpService: HttpService, 
        public metaService: MetaService
    ) {}

    @Post() 
    // @UseGuards(AuthGuard('jwt'))
    async createUpdateProperty(oldData, newData){
        return await this.propertyService.createOrUpdate(oldData, newData);
    }


    @Get('sync') 
    // @UseGuards(AuthGuard('jwt'))
    async patchNewProperty(@Body() patchproperty: Property){


        console.log(" { patchproperty } ")

            let xmlAttempt = await this.httpService.get('https://rkproperty.mycrm.com/feed/genericportal/40157279725f1929a6ccbc03e2ee067d')

            xmlAttempt.subscribe((response) => {
                return new Parser({explicitArray: false}).parseString(response.data, (err, _xmlData) => {
                    if(err) {
                        throw err;
                    }
                    console.log("{_propertiesMeta}, _.get(_xmlData, 'list.$')")

                    this.metaService.findOneByMeta(META_CONSTANTS.propertiesMeta).then(_propertiesMeta => {
                        if(!_.get(_propertiesMeta, 'data.last_update') || _.get(_propertiesMeta, 'data.last_update') !=  _.get(_xmlData, 'list.$.last_update')){
                            // if(!_.get(_propertiesMeta, 'data.last_update') || _.get(_propertiesMeta, 'last_update') !=  _.get(_xmlData, 'list.$.last_update')){
                            console.log("NOUPDATE : ", {_propertiesMeta}, _.get(_propertiesMeta, 'data.last_update'),  _.get(_xmlData, 'list.$.last_update'))
                            console.log("_propertiesMeta last_update : ", _.get(_xmlData, 'list.$.last_update'))

                            this.metaService.createOrUpdate( META_CONSTANTS.propertiesMeta, _.get(_xmlData, 'list.$', {}))

                            this.propertyService.getAllProperties().then(getAllProperties=> {

                            // this.propertyService.updateManyProperties()

                            _.forEach( _.get(_xmlData, 'list.property', []), _property => {
        
                                let _newProperty = _.omit(_property, '$')
                                _.set(_newProperty, 'photo.url', _.map(_.get(_newProperty, 'photo.url', []), _image => _.get(_image, '_')) )
                                _.set(_newProperty, 'last_update', _.get(_property, '$.last_update'))
        
                                // console.log("------ > ", _.get(_property, 'reference_number'), _.find(getAllProperties, _pr => _.get(_property, 'reference_number') == _.get(_pr, 'reference_number')))


                                    let existingProperty = _.find(getAllProperties, _pr => _.get(_property, 'reference_number') == _.get(_pr, 'reference_number'))
    
    

                                    if(_.get(existingProperty, 'last_update') != _.get(_newProperty, 'last_update'))
                                    console.log("existingProperty ==> ",  _.get(existingProperty, 'last_update'), _.get(_newProperty, 'last_update'))

                                    if(_.get(existingProperty, 'last_update') != _.get(_newProperty, 'last_update') ){

                                        try{
                                            console.log("_newProperty.bedroom BEFORE : ", _newProperty.bedroom, _newProperty.bathroom)

                                            _newProperty.bedroom = Number(_.toString(_newProperty?.bedroom).match(/\d+/g))
                                            _newProperty.bathroom = Number(_.toString(_newProperty?.bathroom).match(/\d+/g))



                                            // if(existingProperty?.bedroom instanceof String)
                                            // existingProperty.bedroom = Number(existingProperty?.bedroom.replaceAll('+', ''))
                                            // if(existingProperty?.bathroom instanceof String)
                                            // existingProperty.bathroom = Number(existingProperty?.bathroom.replaceAll('+', ''))

                                            console.log("_newProperty.bedroom AFTER : ", _newProperty.bedroom, _newProperty.bathroom)
                                            console.log("==============================")
                                        }catch(err){
                                            console.log({err}, {_newProperty})
                                        }

                                        let _property = existingProperty ? this.propertyService.updateProperty(existingProperty, _newProperty) : this.propertyService.createOrUpdate(existingProperty, _newProperty)
                                        _property
                                        .then(result => { 
                                            console.log("Updated : ", _.get(_newProperty, 'title_en'))
                                        })
                                        .catch(err => { 
                                            console.log(err) 
                                        })
                                    }else {
                                        // console.log("NOUPDATE : ", _.get(_newProperty, 'title_en'))
                                    }
            
                                })


                            })
                        }else {
                            console.log("NO UPDATE last update issue")
                        }

                    })
                    
                })
            })
    }


    @Get()
    // @UseGuards(AuthGuard('jwt'))
    async getAllProperties(@Query() params: any) {
        return await this.propertyService.getAllProperties();
    }



    @Post('list')
    // @UseGuards(AuthGuard('jwt'))
    async getAllPropertiesFiltered(@Body() params: any) {
        return await this.propertyService.getAllPropertiesFiltered(params);
    }
    


    @Get(':reference_number')
    // @UseGuards(AuthGuard('jwt'))
    async getSingleProperty(@Param('reference_number') reference_number) {
        return await this.propertyService.findOneByProperty(reference_number);
    }
}