import { HttpModule } from '@nestjs/axios';
import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { MetasModule } from 'src/meta/meta.module';
import { PropertyController } from './property.controller';
import { PropertyService } from './property.service';
import { PropertySchema } from './propertySchema';

@Module({
  imports: [
    MongooseModule.forFeature([{name: 'Property', schema: PropertySchema}]),
    HttpModule,
    MetasModule
  ],
  exports: [PropertyService],
  controllers: [PropertyController],
  providers: [PropertyService]
})
export class PropertysModule {}
